Bug 1472663 - Review Request: variety - Wallpaper changer that automatically downloads wallpapers
Review Request: variety - Wallpaper changer that automatically downloads wall...
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Robert-André Mauchin
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-07-19 03:38 EDT by MartinKG
Modified: 2017-08-22 13:08 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-08-22 13:08:44 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
zebob.m: fedora‑review+


Attachments (Terms of Use)
Patch to use WebKitGtk4 (693 bytes, patch)
2017-08-21 08:01 EDT, Robert-André Mauchin
no flags Details | Diff

  None (edit)
Description MartinKG 2017-07-19 03:38:08 EDT
Spec URL: https://martinkg.fedorapeople.org/Review/SPECS/variety.spec
SRPM URL: https://martinkg.fedorapeople.org/Review/SRPMS/variety-0.6.4-1.fc26.src.rpm

Description: %description
Variety changes the desktop wallpaper on a regular basis,
using user-specified or automatically downloaded images.

Variety sits conveniently as an indicator in the panel
and can be easily paused and resumed. The mouse wheel
can be used to scroll wallpapers back and forth until
you find the perfect one for your current mood.

Apart from displaying images from local folders, several
different online sources can be used to fetch wallpapers
according to user-specified criteria.

Variety can also automatically apply various fancy
filters to the displayed images - charcoal painting,
oil painting, heavy blurring, etc. - so that your
desktop is always fresh and unique.

Fedora Account System Username: martinkg

rpmlint -i -v variety.spec /home/martin/rpmbuild/SRPMS/variety-0.6.4-1.fc26.src.rpm /home/martin/rpmbuild/RPMS/noarch/variety-0.6.4-1.fc26.noarch.rpm
variety.spec: I: checking
variety.spec: I: checking-url https://launchpad.net/variety/trunk/0.6.4/+download/variety_0.6.4-0-589-201704290523.tar.gz (timeout 10 seconds)
variety.src: I: checking
variety.src: I: checking-url https://launchpad.net/variety (timeout 10 seconds)
variety.src: I: checking-url https://launchpad.net/variety/trunk/0.6.4/+download/variety_0.6.4-0-589-201704290523.tar.gz (timeout 10 seconds)
variety.noarch: I: checking
variety.noarch: I: checking-url https://launchpad.net/variety (timeout 10 seconds)
variety.noarch: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

variety.noarch: W: no-manual-page-for-binary variety
Each executable in standard binary directories should have a man page.

2 packages and 1 specfiles checked; 0 errors, 2 warnings.

%changelog
* Tue Jul 18 2017 Martin Gansser <martinkg@fedoraproject.org> - 0.6.4-1
- initial build
Comment 1 MartinKG 2017-07-19 04:33:04 EDT
rpmlint reports that the package contains no documentation
I opened a Ticket: https://bugs.launchpad.net/variety/+bug/1705199
Comment 2 Robert-André Mauchin 2017-08-18 11:51:32 EDT
It seems you borrowed from my COPR package. I had to update it because of a bug report for missing dependencies. You seem to have removed all Requires: this won't work because variety will be missing some Python lib in some systems.

Please take a look at my updated SPEC: https://copr-be.cloud.fedoraproject.org/results/eclipseo/variety/fedora-rawhide-x86_64/00591522-variety/variety.spec
Comment 3 MartinKG 2017-08-18 16:09:00 EDT
(In reply to Robert-André Mauchin from comment #2)
> It seems you borrowed from my COPR package. I had to update it because of a
> bug report for missing dependencies. You seem to have removed all Requires:
> this won't work because variety will be missing some Python lib in some
> systems.
> 
> Please take a look at my updated SPEC:
> https://copr-be.cloud.fedoraproject.org/results/eclipseo/variety/fedora-
> rawhide-x86_64/00591522-variety/variety.spec

Thanks for the hint.
$ fedora-review fails with IndexError: list index out of range

fedora-review -m fedora-rawhide-x86_64-rpmfusion_free -rn ../SRPMS/variety-0.6.4-2.fc26.src.rpm

Spec URL: https://martinkg.fedorapeople.org/Review/SPECS/variety.spec
SRPM URL: https://martinkg.fedorapeople.org/Review/SRPMS/variety-0.6.4-2.fc26.src.rpm

%changelog
* Fri Aug 18 2017 Martin Gansser <martinkg@fedoraproject.org> - 0.6.4-2
- Add RR python-lxml
- Add RR python-pillow
- Add RR pycairo
- Add RR dbus-python
- Add RR python-appindicator
- Add RR python-beautifulsoup4
- Add RR python-configobj
- Add RR python2-gexiv2
- Add RR python-pycurl
- Add RR python2-requests
- Add RR pyexiv2
- Add RR imagemagick
- Add RR hicolor-icon-theme
- Add BR libappstream-glib
- Add appdata.xml file
Comment 4 Robert-André Mauchin 2017-08-19 02:54:54 EDT
Sorry but I was still missing Requires: I had to add libappindicator-gtk3 and webkitgtk3 as dependency. Also imagemagick is case sensitive, it's ImageMagick.

See https://copr-be.cloud.fedoraproject.org/results/eclipseo/variety/fedora-rawhide-x86_64/00591769-variety/variety.spec

If you want I can review your package later.
Comment 5 MartinKG 2017-08-19 05:55:12 EDT
(In reply to Robert-André Mauchin from comment #4)
> Sorry but I was still missing Requires: I had to add libappindicator-gtk3
> and webkitgtk3 as dependency. Also imagemagick is case sensitive, it's
> ImageMagick.
> 
> See
> https://copr-be.cloud.fedoraproject.org/results/eclipseo/variety/fedora-
> rawhide-x86_64/00591769-variety/variety.spec
> 
> If you want I can review your package later.

yes you can review the package, you are welcome.

Spec URL: https://martinkg.fedorapeople.org/Review/SPECS/variety.spec
SRPM URL: https://martinkg.fedorapeople.org/Review/SRPMS/variety-0.6.4-3.fc26.src.rpm

%changelog
* Sat Aug 19 2017 Martin Gansser <martinkg@fedoraproject.org> - 0.6.4-3
- Add RR libappindicator-gtk3
- Correct RR ImageMagick it's case sensitive
- Add RR webkitgtk3
Comment 6 MartinKG 2017-08-21 04:01:33 EDT
rpmlint reports:
variety.noarch: E: explicit-lib-dependency libappindicator-gtk3

rpmlint -I explicit-lib-dependency
explicit-lib-dependency:
You must let rpm find the library dependencies by itself. Do not put unneeded
explicit Requires: tags.

that means libappindicator-gtk3 should be removed ?
Comment 7 Robert-André Mauchin 2017-08-21 04:21:27 EDT
No, it's just that rpmlint sees lib in the name of the package but rpm won't find the dependency automatically for a Python package. If you remove it, variety will show an error at startup because it can't find libappindicator-gtk3. I received bug reports about this.
Comment 8 Robert-André Mauchin 2017-08-21 08:01 EDT
Created attachment 1316225 [details]
Patch to use WebKitGtk4

Oh we've got another problem:

« The webkitgtk3 package will be removed from rawhide after Fedora 26 is branched due to the high number of unfixed security vulnerabilities. You must remove this dependency or your package will not be present in Fedora 27. »

https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/thread/AKVB363GFCHHJ5MTHGVYHYT6NLLTF5VM/

Hence it can't be installed on F26+. So the only way to fix this is to ask upstream to port their app to the new WebkitGtk+ API. We can't accept the package until this is resolved.
Fortunately, this is patchable easily. I join you the pacth I've made, I let you handle the bug reporting upstream and add the bug number in comment to the patch.

We also need one more BR:
Requires:       pywebkitgtk

I tested the app with those fixes and it works with no error message.
Comment 9 Robert-André Mauchin 2017-08-21 08:02:49 EDT
Forgot to add: the BR to webkitgtk3 becomes webkitgtk4
Comment 10 MartinKG 2017-08-21 08:45:34 EDT
i added your patch and reported upstream.

Spec URL: https://martinkg.fedorapeople.org/Review/SPECS/variety.spec
SRPM URL: https://martinkg.fedorapeople.org/Review/SRPMS/variety-0.6.4-4.fc26.src.rpm

%changelog
* Mon Aug 21 2017 Martin Gansser <martinkg@fedoraproject.org> - 0.6.4-4
- Add %%{name}-%%{version}-fix_webkit_version.patch
- Correct BR webkitgtk3 becomes webkitgtk4
- Add RR pywebkitgtk
Comment 11 Robert-André Mauchin 2017-08-21 09:42:23 EDT
This won't work:

Patch0:         %{name}-%{version}-fix_webkit_version.patch

the filename of the patch won't change, but the version of the package can change: on the next release, if we still need the pacth, it won't find it. Just use the full name without macro:

Patch0:         variety-0.6.4-fix_webkit_version.patch


Otherwise, everything else is good, package accepted.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "*No copyright* GPL (v3)", "*No copyright* CC by-sa (v3.0)",
     "GPL (v3)", "BSD (3 clause) GPL (v3)", "Unknown or generated". 117
     files have unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/variety/review-variety/licensecheck.txt
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/help/C
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: The spec file handles locales properly.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: update-desktop-database is invoked in %post and %postun if package
     contains desktop file(s) with a MimeType: entry.
     Note: desktop file(s) with MimeType entry in variety
[x]: gtk-update-icon-cache is invoked in %postun and %posttrans if package
     contains icons.
     Note: icons in variety
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or
     desktop-file-validate if there is such a file.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: variety-0.6.4-4.fc28.noarch.rpm
          variety-0.6.4-4.fc28.src.rpm
variety.noarch: E: explicit-lib-dependency libappindicator-gtk3
variety.noarch: W: no-manual-page-for-binary variety
2 packages and 0 specfiles checked; 1 errors, 1 warnings.
Comment 12 MartinKG 2017-08-21 09:53:15 EDT
(In reply to Robert-André Mauchin from comment #11)
> This won't work:
> 
> Patch0:         %{name}-%{version}-fix_webkit_version.patch
> 
> the filename of the patch won't change, but the version of the package can
> change: on the next release, if we still need the pacth, it won't find it.
> Just use the full name without macro:
> 
> Patch0:         variety-0.6.4-fix_webkit_version.patch
> 
> 
> Otherwise, everything else is good, package accepted.
> 
 
will change this and use the full package name w/o macro.
Thanks for the review.
Comment 13 Gwyn Ciesla 2017-08-22 09:33:22 EDT
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/variety
Comment 14 MartinKG 2017-08-22 13:08:44 EDT
package has been built successfully on f25, f26, f27 and rawhide.

Note You need to log in before you can comment on or make changes to this bug.